=== debian/changelog ===
openmw (0.48.0-1ubuntu5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:08:17 +1100

openmw (0.48.0-1ubuntu4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:12:18 +0000

openmw (0.48.0-1ubuntu3) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:53:37 +0100

openmw (0.48.0-1ubuntu2) mantic; urgency=medium

  * Rebuild against new libyaml-cpp0.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Sep 2023 07:19:58 +0200

openmw (0.48.0-1ubuntu1) mantic; urgency=medium

  * Build-depend on liblua5.1-0-dev on non-jit archs.  LP: #2030957.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 14 Aug 2023 23:10:04 +0000

openmw (0.48.0-1build1) mantic; urgency=medium

  * Rebuild against new libavcodec60.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Jul 2023 22:03:05 +0200

openmw (0.48.0-1) unstable; urgency=medium

  * Upstream release: OpenMW-0.48.0 (Closes: #1037805)

 -- Bret Curtis <psi29a@gmail.com>  Wed, 19 Jul 2023 17:46:22 +0200

openmw (0.47.0-3) unstable; urgency=medium

  * Team upload
  * Remove unresolvable, unnecessary build-dep
  * Fix video hang with ffmpeg-5 (Closes: #1017801)

 -- Bastian Germann <bage@debian.org>  Sun, 23 Oct 2022 17:46:22 +0200

openmw (0.47.0-2) unstable; urgency=medium

  * Team upload
  * Cherry-pick upstream commit to fix build with glibc 2.34

 -- Bastian Germann <bage@debian.org>  Fri, 21 Oct 2022 14:34:04 +0200
